#include <cpctelera.h>
#include "enemigonew.h"
#include "brujo.h"
#include "demon.h"

#include "constants.h"
#include "map.h"


/***********<Funciones Utiles>***********/

u8 condicionEje(u8 coord, u8 coordObjetivo, u8 sumar){
	u8 coordObjetivoSuma;
	u8 cumple;
	cumple	=	0;
	coordObjetivoSuma	=	coordObjetivo + sumar;
	if((coord >= coordObjetivo) && ( coord <= coordObjetivoSuma))
		cumple	=	1;
	return cumple;
}

u8	cumpleEje(u8 opcionUno, u8 opcionDos){
	u8 devolv;
	devolv	=	0;

	if(opcionUno ||	opcionDos)
		devolv	=	1;
	return devolv;
}

u8 colisionSprites(TEnemigo* ene, u8 x, u8 y){
	u8 colisiona;
	u8 xB, yB;
	u8 xConditionUno,	xConditionDos;
	u8 yConditionUno,	yConditionDos;
	u8 cumpleX,	cumpleY;

	colisiona=0;
	xB	=	ene->x[0];
	yB	=	ene->y[0];

	xConditionUno =	condicionEje( xB, x, ANCHO_ENEMIGO);
	xConditionDos =	condicionEje( (	xB	+	ANCHO_ENEMIGO), x, ANCHO_ENEMIGO);
	yConditionUno =	condicionEje( yB, y, ALTO_ENEMIGO);
	yConditionDos =	condicionEje( (	yB	+	ALTO_ENEMIGO), y, ALTO_ENEMIGO);

	cumpleX	=	cumpleEje(xConditionUno,	xConditionDos);
	cumpleY	=	cumpleEje(yConditionUno,	yConditionDos);
	if(	cumpleX	&&	cumpleY	)
		colisiona	=	1;
	
	return colisiona;

}


/***********</Funciones Utiles>**********/

/**********<Inicializar>*************/

void rangoOidoMinimo(TEnemigo* e){
	u8 xT;
	u8 yT;

	e->preXN = e->xN;
	e->preYN = e->yN;

	if(e->x[0] - (8*e->rangoDeOido)>0){
		xT = e->x[0] - (8*e->rangoDeOido);
	}else{
		xT=0;
	}

	if (e->y[0] - (16*(1+e->rangoDeOido))>0){
		yT = e->y[0] - (16*(e->rangoDeOido));
	}else{
		yT=0;
	}

	if(yT <0 ){
		yT=0;
	}

	e->xN=xT;
	e->yN=yT;
}



void rangoOidoMaximo(TEnemigo* e){

	u8 xT;
	u8 yT;


	e->preXP = e->xP;
	e->preYP = e->yP;

	xT = e->x[0] + (8*e->rangoDeOido);
	yT = e->y[0] + (16*(1+e->rangoDeOido));

	if(xT > LIMITE_DERECHO){
		xT=LIMITE_DERECHO;
	}
	if(yT > LIMITE_INFERIOR){
		yT=LIMITE_INFERIOR;
	}

	e->xP=xT;
	e->yP=yT;
}


void rangoOido(TEnemigo* e){

	rangoOidoMinimo(e);
	rangoOidoMaximo(e);


}

void iniciarEnemigo(TEnemigo *e, u8 x, u8 y, u8 tUCoordX, u8 tUCoordY, u8 tDCoordX, u8 tDCoordY, u8 Eclase){
	e->clase			=	Eclase;
	e->x[0] = e->x[1] = e->x[2] = x;
    e->y[0] = e->y[1] = e->y[2] = y;
	e->px[0] = e->px[1] = e->px[2] = x;
    e->py[0] = e->py[1] = e->py[2] = y;
	e->draw = 2;
	//e->ultimaX;
	//e->ultimaY;
	//e->objeX;
	//e->objeY

	e->posXTelUno		=	tUCoordX;
	e->posYTelUno		=	tUCoordY;
	e->posXTelDos		=	tDCoordX;
	e->posYTelDos		=	tDCoordY;

	e->tile=((x/2)+(y/4)*40);
	if(e->clase==BRUJO) e->sprite =	g_brujo_0;
	if(e->clase==DEMONIO) e->sprite = g_demon_0;
	e->orienta			=	0;
	e->antiguaOrienta	=	0;
	e->tieneObjetivo	=	NO;
	e->vAncho			=	2;
	e->vAlto			=	2;	
	e->bloqueX			=	2;
	e->bloqueY			=	2;
	e->mira				=	NO;
	e->llamar			=	NO;
	e->tiempoLlamada	=	0;
	e->respondiendo		=	100;
	e->haOido			=	NO;	
	e->rangoDeOido		=	1;
	rangoOido(e);
	//e->xN
	//e->xP;
	//e->yN
	//e->yP;
	e->preXN			=	e->xN;
	e->preXP			=	e->xP;
	e->preYN			=	e->yN;
	e->preYP			=	e->yP;
	e->atacando			=	0;
	e->hayBala			=	NO;
	e->xb				=	x;
	e->yb				=	y;
	e->pXB				=	x;
	e->pYB				=	y;
	//e->distX;
	//e->distY;
	//e->memptr;
	//e->memptrBorr;
	e->muerto			=	NO;
	e->muertobien 		= 	NO;

}

/***********</Inicializar>***********/

/****<Calculo de  Distancias>********/
u8 calculoAbsols(u8 x, u8 y){

	i8 aux;
	u8 devol;
	devol	=	0;

	aux	=	x-y;
	if(aux<0)
		aux	=	aux*(-1);
	devol=aux;

	return	devol;
}
u8 disEnemigo2Cosa(u8 x, u8 y, u8 xC, u8 yC){

	u8 componenteUno, componenteDos;
	u8 distancia;

	componenteUno	=	calculoAbsols(x, y);
	componenteDos	=	calculoAbsols(xC, yC);
	
	distancia		=	componenteUno	+	componenteDos;
	return	distancia;
}




void calcularDis(TEnemigo* e){
	u8	disP, disT, disTU, disTD;
	u8 x, y;
	u8 xPers, yPers, xTelfU, yTelfU, xTelfD, yTelfD, xTelf, yTelf;
	//cpct_setBorder(HW_ORANGE);
	
	x		=	e->x[0];
	y		=	e->y[0];

	xPers	=	e->ultimaX;
	yPers	=	e->ultimaY;

	xTelfU	=	e->posXTelUno;
	yTelfU	=	e->posYTelUno;

	xTelfD	=	e->posXTelDos;
	yTelfD	=	e->posYTelDos;

//	calculo( x, y, xPers, yPers, xTelf, yTelf);
/*	disP	=	disEnemigo2Cosa(x, y, xPers, yPers);
	disTU	=	disEnemigo2Cosa(x, y, xTelf, yTelf);
*/
	disP	=	disEnemigo2Cosa(x, xPers, y, yPers);
	disTU	=	disEnemigo2Cosa(x, xTelfU, y, yTelfU);
	disTD	=	disEnemigo2Cosa(x, xTelfD, y, yTelfD);



	if(disTU	<=	disTD){
		xTelf	=	xTelfU;
		yTelf	=	yTelfU;
		disT	= 	disTU;
	}else{
		xTelf	=	xTelfD;
		yTelf	=	yTelfD;
		disT	= 	disTD;
	}

	if(disP > disT){
		e->objeX = xTelf;
		e->objeY = yTelf;
		e->tieneObjetivo	=	SI;
	}else{
		e->objeX = xPers;
		e->objeY = yPers;
		e->tieneObjetivo	=	SI;
	}
	//cpct_setBorder(HW_BRIGHT_YELLOW);
}


/****</Calculo de  Distancias>*******/

/****************************<VISION>********************************/
void actualizarVista(TEnemigo* e){
	if(e->orienta==0 || e->orienta==2){
		e->bloqueX = e->vAncho;
		e->bloqueY = e->vAlto;
	}else{
		e->bloqueX = e->vAlto;
		e->bloqueY = e->vAlto;
	}	
}

u8 visionEnEje(u8 eje, u8 bloque, u8 rango, u8 coord){

	u8 veo;
	veo=0;
	

	if 		((coord < eje)	&& (coord > (eje - (rango * bloque)))){
		veo	=	1;
	}else if((coord > eje)	&& (coord < (eje + (rango * bloque)))){
		veo	=	2;
	}
	return veo;
}

u8 seVe(u8 posicion, u8 x, u8 y){
	u8	visto;
	visto=0;
	if(x == 0 || y == 0){
		visto=0;
	}else if(x == 1 && y == 1){

		if(posicion == 2 || posicion == 1){
			visto=1;
		}
	}else if(x == 1 && y == 2){

		if(posicion == 2 || posicion == 3){
			visto=2;
		}
	}else if(x == 2 && y == 1){

		if(posicion == 0 || posicion == 1){
			visto=3;
		}
	}else if(x == 2 && y == 2){
	
		if(posicion == 0 || posicion == 3){
			visto=4;
		}
	}



	return visto;	
}
 


void visionPersonaje(TEnemigo* e, u8 coordX, u8 coordY){


	u8 vistoEnX, vistoEnY;
	vistoEnX	=	visionEnEje(e->x[0], e->bloqueX, ANCHO_ENEMIGO, coordX);
	vistoEnY	=	visionEnEje(e->y[0], e->bloqueY, ALTO_ENEMIGO, coordY);
	e->mira 	=	seVe(e->orienta, vistoEnX, vistoEnY);


}

void vision(TEnemigo* e, u8 coordX, u8 coordY){

	//cpct_setBorder(HW_BRIGHT_WHITE);
	if(!e->tieneObjetivo){
		if(e->antiguaOrienta != e->orienta){
		
			actualizarVista(e);
		}
		e->antiguaOrienta = e->orienta;
		visionPersonaje(e, coordX, coordY);


		if(e->mira!=0){
			e->ultimaX	=	coordX;
			e->ultimaY	=	coordY;
		}
	}
	//cpct_setBorder(HW_BLUE);
}
/****************************</VISION>*******************************/

/****************************<OIDO>*******************************/
u8 oyeEnEje(u8 n, u8 p, u8 nT, u8 pT){

	u8 oye;
	u8 oyeN;
	u8 oyeP;
	oye=0;
	oyeN=0;
	oyeP=0;

	if(n >= nT && n <= pT)
		oyeN=1;
	if(p >= nT && p <= pT)
		oyeP=1;


	if(oyeN==1 || oyeP== 1){
		oye=1;
	}

	return oye;
}

u8 oye(u8 xN, u8 xP, u8 yN, u8 yP, u8 xNT, u8 xPT, u8 yNT, u8 yPT){
	u8 oir;

	u8 cumpleX, cumpleY;
	u8* memptr;
	oir=0;


	
	memptr = cpct_getScreenPtr(VMEM, 70, 100); 
	cumpleX= oyeEnEje(xN, xP, xNT, xPT);
	cumpleY= oyeEnEje(yN, yP, yNT, yPT);

	if(cumpleX==1 && cumpleY==1)
		oir=1;

	if(oir){

		cpct_drawSolidBox(memptr, 5, 4, 4); 
	}else{
		cpct_drawSolidBox(memptr, 0, 4, 4); 
	}	

	return oir;
}


u8 localizarTelf(TEnemigo* e, u8 telf, u8 xNT, u8 xPT, u8 yNT, u8 yPT){
	u8 oir;
	u8 coordX, coordY;
	u8 llego;
	u8 xN, xP, yN, yP;

	llego	=	0;

	//cpct_setBorder(HW_BRIGHT_GREEN);
	xN	=	e->xN;
	xP	=	e->xP;
	yN	=	e->yN;
	yP	=	e->yP;

	if(telf==0){
		coordX	=	e->posXTelUno;
		coordY	=	e->posYTelUno;
	}else{
		coordX	=	e->posXTelDos;
		coordY	=	e->posYTelDos;
	}

	if(e->tieneObjetivo==0){


		oir=oye(xN, xP, yN, yP, xNT, xPT, yNT, yPT);
		if(oir){
			e->objeX	= coordX;
			e->objeY	= coordY;
			e->tieneObjetivo=1;
		}
	}
	if(e->tieneObjetivo && e->llamar!=telf){
	//cpct_setBorder(HW_BLACK);
		if(colisionSprites(e, e->x[0], e->y[0])){ //Tiene que estar dentro de rango
				
		e->respondiendo--;
			if(!e->respondiendo)
				llego=1;
		}
//	cpct_setBorder(HW_PASTEL_GREEN);
	}

	//cpct_setBorder(HW_BLACK);
	return llego;


}
/****************************</OIDO>******************************/

/****************************<MOVIMIENTO>****************************/
//Orienta 0
void moverMaloDerecha(TEnemigo* e){
	if( e->x[0] < 72 && (mapa[4+(e->tile)] != 1) && (mapa[84+(e->tile)]!= 1) && (mapa[164+(e->tile)]!= 1)) {
		e->draw = 2;
		e->x[0]++;
		if(e->clase==BRUJO) e->sprite =	g_brujo_0;
		if(e->clase==DEMONIO) e->sprite =	g_demon_0;
	}else{

		e->orienta=1;
	}
}

//Orienta 1
void moverMaloArriba(TEnemigo* e){
	
	if ( e->y[0] > 0 && (mapa[-40+(e->tile)] != 1) && (mapa[-38+(e->tile)]!= 1) && (mapa[-36+(e->tile)]!= 1)) {
		e->draw = 2;
		e->y[0]-=2;
		if(e->clase==BRUJO) e->sprite =	g_brujo_3;
		if(e->clase==DEMONIO) e->sprite =	g_demon_3;
		
	}
	else{

		e->orienta=2;
	}
}

//Orienta 2
void moverMaloIzquierda(TEnemigo* e){
	
	if ( e->x[0] > 0 && (mapa[-1+(e->tile)] != 1) && (mapa[79+(e->tile)]!= 1) && (mapa[159+(e->tile)]!= 1)) {
		e->draw = 2;
		e->x[0]--;
		if(e->clase==BRUJO) e->sprite =	g_brujo_1;
		if(e->clase==DEMONIO) e->sprite =	g_demon_1;
		
	}else{

		e->orienta=3;
	}
}

//Orienta 3
void moverMaloAbajo(TEnemigo* e){
	if ( e->y[0] < 184 && (mapa[200+(e->tile)] != 1) && (mapa[202+(e->tile)]!= 1) && (mapa[204+(e->tile)]!= 1)) {
		e->draw = 2;
		e->y[0]+=2;
		if(e->clase==BRUJO) e->sprite =	g_brujo_2;
		if(e->clase==DEMONIO) e->sprite =	g_demon_2;
	
	}else{

		e->orienta=0;
	}
}

void moverMaloDefecto(TEnemigo* e){
	if(e->orienta==0){
		moverMaloDerecha(e);
		
	}else if(e->orienta==1){
		moverMaloArriba(e);
	}
	else if(e->orienta==2){
		moverMaloIzquierda(e);
	}
	else if(e->orienta==3){
		moverMaloAbajo(e);
	}
}
void moverMaloObjetivo(TEnemigo* e){
	if( !((e->x[0] == e->objeX)&&(e->y[0] == e->objeY))){
	//	cpct_setBorder(HW_BLUE);
		if(e->x[0] < e->objeX){

			moverMaloDerecha(e);
	
		}
		if(e->x[0] > e->objeX){

			moverMaloIzquierda(e);
		}
		if(e->y[0] <= e->objeY){
			
			moverMaloAbajo(e);
		}
		if(e->y[0] >= e->objeY){
			
			moverMaloArriba(e);
		}
	}else{
	//	cpct_setBorder(HW_ORANGE);
		e->tieneObjetivo	=	NO;

	}
}

void moverse(TEnemigo* e){
	e->px[0]	=	e->x[0];
	e->py[0]	=	e->y[0];
	e->memptrBorr	=	cpct_getScreenPtr(ORIGEN_MAPA, e->px[0], e->py[0]); 
//	cpct_setBorder(HW_BRIGHT_YELLOW);		
	if(e->tieneObjetivo){
		//	cpct_setBorder(HW_BRIGHT_RED);
		moverMaloObjetivo(e);
	}else{
	//		cpct_setBorder(HW_BLACK);
		moverMaloDefecto(e);
	}
	e->tile=((e->x[0]/2)+(e->y[0]/4)*40);
	e->memptr		=	cpct_getScreenPtr(ORIGEN_MAPA, e->x[0], e->y[0]); 
	//cpct_setBorder(HW_BRIGHT_GREEN);	
	
}
/****************************</MOVIMIENTO>***************************/

/****************************<Llamar>*******************************/
void hacerLlamado(TEnemigo* e){
	u8 enTelfUno, enTelfDos;
	enTelfUno	=	colisionSprites(e, e->x[0], e->y[0]);
	enTelfDos	=	colisionSprites(e, e->x[0], e->y[0]);	
	if(enTelfUno){
			e->llamar	=	1;
	}else if(enTelfDos){
			e->llamar	=	2;
	}else{
			e->llamar	=	0;
	}
}
/****************************</Llamar>******************************/

/****************************<ACTUALIZAR>*****************************/
void actualizarEnemigo(TEnemigo* e, u8 coordX, u8 coordY){
	if(!e->muerto){
		//if(e->tieneObjetivo	==	NO)
	//cpct_setBorder(HW_BRIGHT_YELLOW);	
		
			vision(e,coordX,coordY);
			moverse(e);
	//	 cpct_setBorder(HW_LIME);

		 if(!e->llamar)
			hacerLlamado(e);
	//	 cpct_setBorder(HW_PASTEL_CYAN);


			rangoOido(e);
	//	 cpct_setBorder(HW_ORANGE);	
		if(e->mira	!=	0){
		/*	e->objeX	=	e->ultimaX;
			e->objeY	=	e->ultimaY;
			e->tieneObjetivo=1;*/
			if(!e->tieneObjetivo){
				calcularDis(e);
			}
		}

//	 cpct_setBorder(HW_BRIGHT_RED);
	if(e->atacando){
		if(colisionSprites(e, e->objeX, e->objeY)){
			e->atacando = 0;
			e->tieneObjetivo = 0;
		}
	}
	}else{
		if(e->muerto != e->muertobien){

			e->x[0] = e->x[1] = e->x[2] = 50;
			e->y[0] = e->y[1] = e->y[2] = 50;
			clearEntityEM(e);
			e->muertobien = e->muerto;
			//e->draw=0;
		}
	}
}

/****************************</ACTUALIZAR>****************************/

/****************************</DIBUJAR>*******************************/

void clearEntityE(TEnemigo* e){
   //u8* memptr = cpct_getScreenPtr(g_backBuffer, p->px[2], 40 + p->py[2]);
   u8 w = 4 + (e->px[2] & 1);
   u8 h = 4 + (e->py[2] & 3 ? 1: 0);
   cpct_etm_drawTileBox2x4 (e->px[2] / 2, e->py[2] / 4, w, h, g_map1_W, cpctm_screenPtr(g_backBuffer, 0, 40), mapa);
   e->px[0] = e->x[0];
   e->py[0] = e->y[0];
}

void clearEntityEM(TEnemigo* e){
   //u8* memptr = cpct_getScreenPtr(g_backBuffer, p->px[2], 40 + p->py[2]);
	
   u8 w = 4 + (e->x[0] & 1);
   u8 h = 4 + (e->y[0] & 3 ? 1: 0);
   cpct_etm_drawTileBox2x4 (e->x[0] / 2, e->y[0] / 4, w, h, g_map1_W, ORIGEN_MAPA, mapa);
   cpct_etm_drawTileBox2x4 (e->x[0] / 2, e->y[0] / 4, w, h, g_map1_W, ORIGEN_MAPA2, mapa);
}

void drawEntityE(TEnemigo* e){
   
	if(!e->muerto){
	   u8* memptr = cpct_getScreenPtr(g_backBuffer, e->x[0], 40 + e->y[0]);
	   cpct_drawSpriteMaskedAlignedTable (e->sprite, memptr, 8, 16, g_tablatrans);
	}
}

void entityDrawUpdateE(TEnemigo* e){
   

   u8* x = e->x +2;
   u8* y = e->y +2;
   u8* px = e->px +2;
   u8* py = e->py +2;
  
   *x = *(x-1); --x; *x = *(x-1);
   *y = *(y-1); --y; *y = *(y-1);
   
   *py = *(py-1); --py; *py = *(py-1);
   *px = *(px-1); --px; *px = *(px-1);

   //resetAnim();
   
   --e->draw;

}