/***********Enemigo**************/

#include <cpctelera.h>


//#define VMEM (u8*) 0xC000
#define		SI 1
#define		NO 0

#define BRUJO 0
#define DEMONIO 1

#define ANCHO_ENEMIGO 8
#define ALTO_ENEMIGO 16

#define ANCHO_PANTALLA	80
#define LIMITE_DERECHO ANCHO_PANTALLA - ANCHO_ENEMIGO

#define ALTO_PANTALLA	180
#define LIMITE_INFERIOR ALTO_PANTALLA 

typedef struct {
	u8 clase;	//	Clase del enemigo (BRUJO, CIEGO, FANTASMA)
	
	/*Posiciones*/
		
		/*Posiciones del enemigo*/
			u8 x[3], y[3];	//	Posicion actual del enemigo
			u8 px[3], py[3];	//	Posicion previa del enemigo para borrado
		/************************/
			u8 draw;
		/*Ultima posicion del personaje conocida*/
			u8 ultimaX, ultimaY;
		/****************************************/
		
		/*Posicion objetivo*/
			u8 objeX, objeY;	//	Posicion del objetivo actual
		/*******************/
		
		/*Posicion de los telefonos*/
			u8 posXTelUno, posYTelUno;	//	Coordenada x del primer telefono, coordenada y del primer telefono
			u8 posXTelDos, posYTelDos;	//	Coordenada x del segundo telefono, coordenada y del segundo telefono
		/***************************/
	u16 tile;		//Tile en el que se encuentra
	/************/

	/*Sprite*/
		u8* sprite;
	/********/
	/*Orientacion*/
		u8 orienta;	//	Orientacion que posee el enemigo 0 derecha, 1 arriba, 2 izquierda, 3 abajo
		u8 antiguaOrienta;
	/*************/

	/*Obtencion de objetivo*/
		u8 tieneObjetivo;	//	El enemigo tiene objetivo 1 o no lo tiene 0
	/***********************/

	/*Variables de vision*/
		u8 vAncho, vAlto;		//	Dimensiones dee ancho y alto de la vision del enemigo
		u8 bloqueX, bloqueY;	//	Hasta donde ve en el eje X y en el eje Y
		u8 mira;				//	Cuadrante en hacia el que esta localizado el personaje en la vision del enemigo (Arriba izq, abajo izq, arriba der, abajo der) 
	/*********************/

	/*Variables de llamada*/
		u8 llamar;			//	El enemigo va a llamar 1 telefono uno, 2 telefono Dos, o no 0
		u8 tiempoLlamada;	//	Cuanto tiempo estará el personaje llamando esperando una respuesta
		u8 respondiendo;	
	/***********************/

	/*Variables de Escucha*/
		u8 haOido;			// El enemigo ha oido un ruido 1 o no 0

		/*Rango de escucha*/
		u8 rangoDeOido;	//	Hasta donde alcanza el oido del personaje
			u8 xN, xP;	//	x Izquirda, x Derecha
			u8 yN, yP;	//	y izquierda, y Derecha
			/*Para borrarRangos(Esto hay que quitarlo*/
				u8 preXN, preXP, preYN, preYP;
			/*****************************************/
		/******************/
	/**********************/

	/*Variables de ataque*/
		u8 atacando;
		/*Bala*/	//	(Esto se quitará y se utilizara la bala implementada de Miguel)
			u8 hayBala;
			u8 xb, yb;
			u8 pXB, pYB;
		/******/
	/*********************/

	/*Distancia*/
		u8 distX, distY;	//Distancia de la coordenadas respecto a las coordenadas de otro objeto (resta)
	/***********/

	/*Variables Dibujo*/
		u8* memptr;		//	Puntero direccion memoria		
		u8* memptrBorr;	//	Puntero direccion memoria borrar
	/******************/

	/*Variable de estado*/
		u8 muerto;		//	El enemigo esta muerto o no
	/********************/		
		u8 muertobien;

	

}TEnemigo;

/***********<Funciones Utiles>***********/
u8 condicionEje(u8 coord, u8 coordObjetivo, u8 sumar);
u8 cumpleEje(u8 opcionUno, u8 opcionDos);
u8 colisionSprites(TEnemigo* ene, u8 x, u8 y);
/***********</Funciones Utiles>**********/

/**********<Inicializar>*************/
void rangoOidoMinimo(TEnemigo* e);
void rangoOidoMaximo(TEnemigo* e);
void rangoOido(TEnemigo* e);
void iniciarEnemigo(TEnemigo *e, u8 x, u8 y, u8 tUCoordX, u8 tUCoordY, u8 tDCoordX, u8 tDCoordY, u8 Eclase);
/***********</Inicializar>***********/
/****<Calculo de  Distancias>********/
u8 calculoAbsols(u8 x, u8 y);
u8 disEnemigo2Cosa(u8 xE, u8 yE, u8 xC, u8 yC);
void calcularDis(TEnemigo* e);


/****</Calculo de  Distancias>*******/
/****************************<VISION>********************************/
void actualizarVista(TEnemigo* e);
u8 visionEnEje(u8 eje, u8 bloque, u8 rango, u8 coord);
u8 seVe(u8 posicion, u8 x, u8 y);
void visionPersonaje(TEnemigo* e, u8 coordX, u8 coordY);
void vision(TEnemigo* e, u8 coordX, u8 coordY);

/****************************</VISION>*******************************/

/**************************<Oido>************************************/
u8 oyeEnEje(u8 n, u8 p, u8 nT, u8 pT);
u8 oye(u8 xN, u8 xP, u8 yN, u8 yP, u8 xNT, u8 xPT, u8 yNT, u8 yPT);
u8 localizarTelf(TEnemigo* e, u8 telf, u8 xNT, u8 xPT, u8 yNT, u8 yPT);

/**************************</Oido>***********************************/

/***********<Movimiento>************/
void moverMaloDerecha(TEnemigo* e);
void moverMaloIzquierda(TEnemigo* e);
void moverMaloAbajo(TEnemigo* e);
void moverMaloArriba(TEnemigo* e);
void moverMaloDefecto(TEnemigo* e);
//void moverMaloMira(TEnemigo* e);
void moverMaloObjetivo(TEnemigo* e);
//void moverMalo(TEnemigo *e);
//void moverATelefono(TEnemigo *e);
void moverse(TEnemigo* e);
/**********</Movimiento>************/
/**********<Llamar>*****************/

/**********</Llamar>****************/
void hacerLlamado(TEnemigo* e);
/**********<Actualizar>*************/
void actualizarEnemigo(TEnemigo* e, u8 coordX, u8 coordY);
/**********</Actualizar>************/

/***********<Dibujar>***************/

void dibuRangoOidoEne(TEnemigo* t);
/**********</Dibujar>***************/

void clearEntityE(TEnemigo*	e);
void drawEntityE(TEnemigo* e);
void entityDrawUpdateE(TEnemigo* e);
void clearEntityEM(TEnemigo* e);