//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include "title.h" //pantalla de inicio
#include "personaje.h" //personaje
#include "maptile.h" // para cpct_etm_setTileset2x4(g_tileset);
//#include "map.h" // mapa=mapa=g_map1;
#include "bala.h"
#include "music.h"
#include "constants.h"
#include <stdio.h>
#include "enemigonew.h"
//#define NUMERO_DE_ENEMIGOS 2
#define NUMERO_DE_ENEMIGOS 2
#define TM_WIDTH 40
#define TM_HEIGHT 40

/*********** MAPA**********/
#define NUM_MAPAS 		5
#define NUM_ENEMIGOS	2

#define SCR_BUFF  (u8*)0x8000

Tpersonaje personaje;
TBala bala;

extern u8 g_mapa[TM_WIDTH*TM_HEIGHT];

const TEnemigo enemigosExist[NUMERO_DE_ENEMIGOS];
TEnemigo* enemy;
const u8 coordenadas[NUM_MAPAS*2]= 	 {60, 20, 20 , 90, 40, 80, 15, 90, 60, 20};
const u8 coordenadasPj[NUM_MAPAS*2]= {10, 20, 20, 5  , 5 , 5 , 35, 75, 15, 20};
const u8 clases[5]= {BRUJO, DEMONIO, DEMONIO, DEMONIO, DEMONIO};
u8* posiciones;

void dummy_initializers() {
	__asm
		//Video memory and Backbuffer
	_g_backBuffer::	.dw 0x8000	//3ºpage
	_g_screenMem::	.dw 0xC000	//4ºpage

	__endasm;
}

void switchBuffers() {

	u8* aux	= g_backBuffer;
	g_backBuffer = g_screenMem;
	g_screenMem	= aux;

	//Set videomemory page
	cpct_setVideoMemoryPage( ((u16)g_screenMem) >> 10);

}

extern void play();

u8 enemigos;
u8 score;
u8 vidas;
u8 scoreF;
u8 vidasF;
u8 state;

u8 i;

//MAPA A DIBUJAR EN PANTALLA
void dummy_f() __naked {

	__asm
	_g_mapa::
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	   
	__endasm;
}
//MAPAS EN 2BITARRAY
const CPCT_2BITARRAY(g_map3, (TM_WIDTH*TM_HEIGHT))= {
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00001111, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00001111, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01010101, 0b01010000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01000000, 0b00000101, 0b01010101,
	0b01010101, 0b01010000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01000000, 0b00000101, 0b01010101,
	0b01010101, 0b01010000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01000000, 0b00000101, 0b01010101,
	0b01010101, 0b01010000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01000000, 0b00000101, 0b01010101,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000011, 0b11000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000011, 0b11000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000101, 0b01010000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,

};

const CPCT_2BITARRAY(g_map4, (TM_WIDTH*TM_HEIGHT))= {
0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00111100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00111100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00111100, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00111100, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
};

const CPCT_2BITARRAY(g_map6, (TM_WIDTH*TM_HEIGHT))= {
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00111100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00111100, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00111100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00111100, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000101, 0b01010101, 0b01010101, 0b01000000, 0b00000001, 0b01010101, 0b01010101, 0b01010000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
};

const CPCT_2BITARRAY(g_map7, (TM_WIDTH*TM_HEIGHT))= {
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b11110000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b11110000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00001111, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00001111, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
};

const CPCT_2BITARRAY(g_map8, (TM_WIDTH*TM_HEIGHT))= {
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000011, 0b11000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000011, 0b11000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000000, 0b00000001,
	0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101,
	0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101,
	0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101,
	0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101,
	0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101,
	0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101,
	0b01000000, 0b00000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000001, 0b01010101,
	0b01000000, 0b00000000, 0b00000000, 0b00000001, 0b01010101, 0b01010101, 0b01000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000011, 0b11000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000011, 0b11000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01000000, 0b00000000, 0b00000000, 0b00000000, 0b00010101, 0b01010100, 0b00000000, 0b00000000, 0b00000000, 0b00000001,
	0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101, 0b01010101,
};

/*************************************************************************************************************************/
/*************************************************************************************************************************/
/*************************************************************************************************************************/
/*************************************************************************************************************************/
/****************MAPAS EN ARRAYBITS***************************************************************************************/
/*************************************************************************************************************************/
/*************************************************************************************************************************/
/*************************************************************************************************************************/
/*************************************************************************************************************************/
/*************************************************************************************************************************/
/*************************************************************************************************************************/
u8* const mapas[NUM_MAPAS] = { g_map3, g_map4, g_map6, g_map7, g_map8};
u8 num_mapa;	
u8* posiciones_Enemigos[NUM_ENEMIGOS*2];

/*MAPA*/
u8 obtenerTile(u8 x, u8 y) {
   	u16 idx = 40*y+x;
  	u8 valor = 0	; 
   	valor  = (cpct_get2Bits(mapas[num_mapa], idx));
	return valor;
}


void leerMapa(){
	u8 i, j, cont_enemigos=0; 
	for(i = 0; i<40; i++){
		for(j = 0; j<40; j++){
			g_mapa[i+(40*j)] = obtenerTile(i, j);
		}
	}
}

void cambiarMapa(){	
	if (num_mapa < NUM_MAPAS-1) {
     	num_mapa++; 
      	mapa = mapas[num_mapa];
      	leerMapa();
     	//dibujarMapa();
   	}
   	else{
   		num_mapa = 0;
   		state = MENU;

	}
}

void dibujarMapa(){
	u8* pvmem;
	u8* pvmem2;
	pvmem = cpct_getScreenPtr(0x8000, 0, 40);
	pvmem2 = cpct_getScreenPtr(0xC000, 0, 40);
	cpct_clearScreen(0);
	leerMapa();
	cpct_etm_drawTilemap2x4(TM_WIDTH, TM_HEIGHT, pvmem, g_mapa);

	cpct_clearScreen(0);
	cpct_etm_drawTilemap2x4(TM_WIDTH, TM_HEIGHT, pvmem2, g_mapa);
}
///////////////////////////////////////////////////////////////////////////////////////
void intHandler(){
	if(++i == 6){
		//cpct_akp_musicPlay();
		play();
		i = 0;
	}
}
/*
void drawMapa(){
   cpct_etm_drawTilemap2x4(g_map1_W, g_map1_H, ORIGEN_MAPA, mapa);
}
*/
void updateScore(){
	u8  str[3]; // sCORE
	u8* memptr1;
	u8* memptr2;
	//memptr1 = cpct_getScreenPtr(VMEM, 38, 15);
	memptr1 = cpct_getScreenPtr(0x8000,  38, 15);
	memptr2 = cpct_getScreenPtr(0xC000,  38, 15);

	cpct_drawStringM0 ("SCORE: ", memptr1, 5, 0);
	cpct_drawStringM0 ("SCORE: ", memptr2, 5, 0);

   // Draw HI-Score
   memptr1 = cpct_getScreenPtr(0x8000, 64,  15);
   memptr2 = cpct_getScreenPtr(0xC000, 64,  15);

   sprintf(str,"%-4u", score);
   cpct_drawStringM0(str, memptr1, 5, 0);
   cpct_drawStringM0(str, memptr2, 5, 0);
}

void updateLife(){
	u8  str[1]; // Lives
	u8* memptr1;
	u8* memptr2;
	u8* memptr3;
	memptr1 = cpct_getScreenPtr(0x8000, 5, 15);
	memptr2 = cpct_getScreenPtr(0xC000, 5, 15);
	cpct_drawStringM0 ("LIVES: ", memptr1, 5, 0);
	cpct_drawStringM0 ("LIVES: ", memptr2, 5, 0);

   // Draw HI-Score
	memptr1 = cpct_getScreenPtr(0x8000, 30,  15);
	//memptr2 = cpct_getScreenPtr(0xC000, 30,  15);
	memptr3 = cpct_getScreenPtr(0xC000, 30, 15);
   sprintf(str,"%1u", vidas);
   cpct_drawStringM0(str, memptr1, 5, 0);
   cpct_drawStringM0(str, memptr3, 5, 0);
}


u8 colisionBalaObjetivo(u8 x, u8 y){
	u8 colisiona;
	u8 xB, yB;
	u8 xConditionUno,	xConditionDos;
	u8 yConditionUno,	yConditionDos;
	u8 cumpleX,	cumpleY;
	
	colisiona=0;
	xB	=	bala.x[0];
	yB	=	bala.y[0];
	

	xConditionUno =	condicionEje( xB, x, ANCHO_ENEMIGO);
	xConditionDos =	condicionEje( (	xB	+	2), x, ANCHO_ENEMIGO);
	yConditionUno =	condicionEje( yB, y, ALTO_ENEMIGO);
	yConditionDos =	condicionEje( (	yB	+	4), y, ALTO_ENEMIGO);

	cumpleX	=	cumpleEje(xConditionUno,	xConditionDos);
	cumpleY	=	cumpleEje(yConditionUno,	yConditionDos);
	if(	cumpleX	&&	cumpleY	)
		colisiona	=	1;
	
	return colisiona;
}

void menu(){
	u8* memptr;
	//Borrar pantalla
	cpct_clearScreen(0);

	memptr = cpct_getScreenPtr(VMEM, 20, 60);
	cpct_drawStringM0 ("RING RING", memptr, 13, 0);

	//cpct_drawSpriteMasked (g_title, cpctm_screenPtr(CPCT_VMEM_START, 0, 0), G_TITLE_W, G_TITLE_H );
	cpct_drawSprite (g_title, cpctm_screenPtr(CPCT_VMEM_START, 28, 75), G_TITLE_W, G_TITLE_H );
	//cpct_drawSpriteMaskedAlignedTable (g_title, cpctm_screenPtr(CPCT_VMEM_START, 0, 0), 20, 24, g_tablatrans);
	memptr = cpct_getScreenPtr(VMEM, 18, 140);
	cpct_drawStringM0 ("1: PLAY", memptr, 8, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 160);
	cpct_drawStringM0 ("2: CONTROLS", memptr, 8, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 180);
	cpct_drawStringM0 ("3: CREDITS", memptr, 8, 0);

	// Esperar hasta Intro

	while(state == MENU) {
		cpct_scanKeyboard_f();
		if(cpct_isKeyPressed(Key_1)){ state = JUGAR;}
		else if(cpct_isKeyPressed(Key_2)){ state = CONTROLES;}
		else if(cpct_isKeyPressed(Key_3)){ state = CREDITOS;}
	}

}

void matarEnemigos(u8 numeroEnemigos){
	numeroEnemigos	+=	1;
	enemy 			=	enemigosExist;

	while(--numeroEnemigos){
		if(!enemy->muerto){
			if(colisionBalaObjetivo(enemy->x[0], enemy->y[0])){
				
				enemy->x[0] = enemy->x[1] = enemy->x[2] = 50;
				enemy->y[0] = enemy->y[1] = enemy->y[2] = 50;
				clearEntityEM(enemy);
				enemy->muerto=SI;
				score=score+10;
			
				enemigos--;

				bala.move=0;
				bala.draw=2;
				
			}
		}
	enemy++;
		
	}	
}

void drawEnemies(u8 numeroEnemigos){
	numeroEnemigos	+=	1;
	enemy			=	enemigosExist;
	while(--numeroEnemigos){
	
	if(enemy->draw){
			clearEntityE(enemy);
			drawEntityE(enemy);
			entityDrawUpdateE(enemy);
	}
	
		enemy++;

	}



}

void actuEnemigos(u8 numeroEnemigos){
	numeroEnemigos	+=	1;
	enemy			=	enemigosExist;
	while(--numeroEnemigos){
		actualizarEnemigo(enemy, personaje.x[0], personaje.y[0]);
		enemy++;
		//numeroEnemigos--;
	}
		


}

void iniciarlizarEnemigos(u8 numeroEnemigos){
	u8 i;
	
	numeroEnemigos	+=	1;
	i=0;
	enemy			=	enemigosExist;
	//posiciones	=	coordenadas;
	while(--numeroEnemigos){

		///iniciarEnemigo(enemy, coordenadas[i],coordenadas[i+1],0,0,200,200);
			iniciarEnemigo(enemy, coordenadas[i],coordenadas[i+1],0,0,200,200, clases[numeroEnemigos-1]);
		enemy++;
		//posiciones++;
		i=i+2;
//		numeroEnemigos--;
	}
	
	

}


void iniMapa( u8* map, u8 numEnemi){
	mapa		=	map;
	enemigos	=	numEnemi;
}

void iniPantalla(u8* map, u8 cantidadEnemigos){ 	//Metodo para inicializar las pantallas, de momento se le pasa mapa y numero de enemigos, habra modificarlo para pasar
	iniMapa(map, cantidadEnemigos);							//Las posiciones del personaje y de los enemigos
	//iniciarPersonaje(&personaje, coordenadasPj[num_mapa], coordenadasPj[num_mapa+1]);
	iniciarPersonaje(&personaje, coordenadasPj[num_mapa*2], coordenadasPj[(num_mapa*2)+1]);
	iniciarlizarEnemigos(NUMERO_DE_ENEMIGOS);
	cpct_clearScreen(0);
	selectSprite(&personaje);
	//drawMapa();
		dibujarMapa();
		updateLife();
		updateScore();

}
/////////////////////////////////////LECTURA DE TECLADO Y DIBUJADO\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

void game() {
	
   u8  br_y = 55; // Y coordinate of the ByteRealms Logo 
   i8  vy   = 1;  // Velocity of the ByteRealms Logo in Y axis
   u8* pvmem;     // Pointer to video memory (or backbuffer) where to draw sprites

	u8* memptr;
	iniPantalla(g_mapa, NUMERO_DE_ENEMIGOS);
	cpct_setInterruptHandler(intHandler);
	score = 0;
	vidas = 3;
	updateLife();
	updateScore();
	// Loop forever
   while (state==JUGAR){
	   	
	 //  	cpct_waitVSYNC();

		// Comprobar teclado
	   cpct_scanKeyboard_f();	

	   if(cpct_isAnyKeyPressed()){
	   	if( cpct_isKeyPressed(Key_D)){
	   				personaje.draw = 2;
				moveRight(&personaje, g_mapa);
		   }else if ( cpct_isKeyPressed(Key_A)) {
		   	personaje.draw = 2;
				moveLeft(&personaje, g_mapa);
		   }else if ( cpct_isKeyPressed(Key_W)){
		   	personaje.draw = 2;
				moveUp(&personaje, g_mapa);
		   }else if ( cpct_isKeyPressed(Key_S)) {
		   	personaje.draw = 2;
				moveDown(&personaje, g_mapa);  		
		   }else if( cpct_isKeyPressed(Key_Esc) ) {
		   	num_mapa = 0;
		   	 state = MENU;
		   }
		}else{

			Stop(&personaje);
		}

		if ( cpct_isKeyPressed(Key_Space)) {
				/*if(personaje.y[0]>16 && personaje.y[0]<180 && personaje.x[0]>5){*/
				iniciarBala(&bala, personaje.x[0], personaje.y[0], personaje.mirar);
				shoot(&bala, personaje.mirar);  		
				/*}*/
		   }
		if ( cpct_isKeyPressed(Key_1)) {
				personaje.vida=personaje.vida-1;
		   }

			if (cpct_isKeyPressed(Key_4)){
			switchBuffers();
		}
		

		stateExe(&personaje);
		selectSprite(&personaje);
		actuEnemigos(NUMERO_DE_ENEMIGOS);

		// Esperar al retrazado
	   	
	   	//cpct_akp_musicPlay();
	  // 	
	   // Dibujar Personaje
		cpct_waitVSYNC();
	   	switchBuffers();
	   
		if(personaje.draw){
			//reDrawPj(&personaje);
			clearEntity(&personaje);
			drawEntity(&personaje);
			entityDrawUpdate(&personaje);
			//personaje.move = NO;
		}

	//		//Dibujar Bala
		
		if(bala.draw){
			clearEntityB(&bala);
			drawEntityB(&bala);
			entityDrawUpdateB(&bala);
		}

		if(bala.move && bala.draw){
			shoot(&bala, personaje.mirar);
			matarEnemigos(NUMERO_DE_ENEMIGOS);
		}else{
			//clearEntityEB(&bala);
		}

		drawEnemies(NUMERO_DE_ENEMIGOS);
		if(!enemigos){
			cambiarMapa();
			iniPantalla(g_mapa, NUMERO_DE_ENEMIGOS );
		}

	// si cambia vida
		if(vidasF!=vidas){
			updateLife();
			vidasF=vidas;
		}
	// si cambia vida
		if(scoreF!=score){
			updateScore();
			scoreF=score;
		}

	}

}

/////////////////////////////////////PANTALLA CONTROLES\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

void controls() {

	u8* memptr;
	//Borrar pantalla
	cpct_clearScreen(0);

	memptr = cpct_getScreenPtr(VMEM, 18, 20);
	cpct_drawStringM0 ("MOVE UP: W", memptr, 8, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 40);
	cpct_drawStringM0 ("MOVE LEFT: A", memptr, 8, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 60);
	cpct_drawStringM0 ("MOVE DOWN: S", memptr, 8, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 80);
	cpct_drawStringM0 ("MOVE RIGHT: D", memptr, 8, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 100);
	cpct_drawStringM0 ("SHOOT: SPACE", memptr, 8, 0);
	memptr = cpct_getScreenPtr(VMEM, 10, 180);
	cpct_drawStringM0 ("-ESC TO RETURN-", memptr, 8, 0);
	// Esperar hasta Intro

	while(state == CONTROLES) {
		cpct_scanKeyboard_f();
		if(cpct_isKeyPressed(Key_Esc)){ state = MENU;}
	}
}


/////////////////////////////////////PANTALLA CONTROLES\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

void credits() {

	u8* memptr;
	//Borrar pantalla
	cpct_clearScreen(0);
	memptr = cpct_getScreenPtr(VMEM, 5, 0);
	cpct_drawStringM0 ("RING RING WARRIOR", memptr, 4, 8);
	memptr = cpct_getScreenPtr(VMEM, 10, 40);
	cpct_drawStringM0 ("CREATED BY", memptr, 11, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 60);
	cpct_drawStringM0 ("Miguel Paniagua", memptr, 13, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 70);
	cpct_drawStringM0 ("Manuel Gomez", memptr, 13, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 80);
	cpct_drawStringM0 ("Jose Ortiz", memptr, 13, 0);
	memptr = cpct_getScreenPtr(VMEM, 10, 100);
	cpct_drawStringM0 ("MUSIC BY", memptr, 11, 0);
	memptr = cpct_getScreenPtr(VMEM, 18, 120);
	cpct_drawStringM0 ("ARKOS", memptr, 13, 0);
	memptr = cpct_getScreenPtr(VMEM, 24, 150);
	cpct_drawStringM0 ("(C) 2016", memptr, 7, 0);
	memptr = cpct_getScreenPtr(VMEM, 10, 180);
	cpct_drawStringM0 ("-ESC TO RETURN-", memptr, 8, 0);
	// Esperar hasta Intro

	while(state == CREDITOS) {
		cpct_scanKeyboard_f();
		if(cpct_isKeyPressed(Key_Esc)){ state = MENU;}
	}
}
////////////////////////////INICIALIZAR CONFIGURACION, POSICIONES Y ESTADOS\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

void init() {
	cpct_disableFirmware();
	cpct_setVideoMode(0);
	cpct_memset((u8*)0x8000, 0, 0x4000);
	
	cpct_fw2hw(g_palette, 14);
	cpct_setPalette(g_palette, 14);
	cpct_etm_setTileset2x4(g_tileset);
	cpct_akp_musicInit(g_introsong);
	state = MENU;
	num_mapa =0;




}

/////////////////////////////////////COMIENZA PROGRAMA\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

void main(void) {
	cpct_setStackLocation((void*)0x8000);
	init();
	
	while(1){
		//state = MENU;
		if(state==MENU){ menu();}

		if(state==JUGAR){ 
			game();
		} else if (state == CONTROLES){
			controls();
		}else if (state == CREDITOS){
			credits();
		}
		//if(state==JUGAR) game();
		
	}
}
