/***********Personaje**************/
#include <cpctelera.h>
#include "personaje.h"
#include "map.h"

/*****************<INICIAR>**************************/

const TFrame g_frames[KNIGHT_FRAMES] = {
      { g_knight_spritesheet_00 }   ,  { g_knight_spritesheet_01 }
   ,  { g_knight_spritesheet_02 }   ,  { g_knight_spritesheet_03 }
   ,  { g_knight_spritesheet_04 }   ,  { g_knight_spritesheet_05 }
   ,  { g_knight_spritesheet_06 }   ,  { g_knight_spritesheet_07 }
   ,  { g_knight_spritesheet_08 }   ,  { g_knight_spritesheet_09 }
   ,  { g_knight_spritesheet_10 }	 ,  { g_knight_spritesheet_11 }
};

TFrame* const anim_andar_r[MOVE_FRAMES_R] = { 
   &g_frames[0], &g_frames[1], &g_frames[2], &g_frames[3]
};
TFrame* const anim_andar_l[MOVE_FRAMES_L] = { 
   &g_frames[4], &g_frames[5], &g_frames[6], &g_frames[7]
};
TFrame* const anim_andar_u[MOVE_FRAMES_U] = { 
   &g_frames[10], &g_frames[11]
};
TFrame* const anim_andar_d[MOVE_FRAMES_D] = { 
   &g_frames[8], &g_frames[9]
};
void iniciarPersonaje(Tpersonaje *p, u8 x, u8 y){

   p->x[0] = p->x[1] = p->x[2] = x;
   p->y[0] = p->y[1] = p->y[2] = y;
	p->px[0] = p->px[1] = p->px[2] = x;
	p->py[0] = p->py[1] = p->py[2] = y;
	p->move = NO;
	p->tile=((x/2)+(y/4)*40);
	p->nframe[0] = p->nframe[2] = p->nframe[3] = 0;
	p->estado = p->lestado = ST_quieto;
   p->mirar = 0;
   //p->vida = 3;
   //p->score = 0;
   p->draw = 2;

}

void clearEntity(Tpersonaje* p){
   //u8* memptr = cpct_getScreenPtr(g_backBuffer, p->px[2], 40 + p->py[2]);
   u8 w = 4 + (p->px[2] & 1);
   u8 h = 4 + (p->py[2] & 3 ? 1: 0);
   cpct_etm_drawTileBox2x4 (p->px[2] / 2, p->py[2] / 4, w, h, g_map1_W, cpctm_screenPtr(g_backBuffer, 0, 40), mapa);
         p->px[0] = p->x[0];
   p->py[0] = p->y[0];
}

void drawEntity(Tpersonaje* p){
   

   u8* memptr = cpct_getScreenPtr(g_backBuffer, p->x[0], 40 + p->y[0]);
   cpct_drawSpriteMaskedAlignedTable (p->frame->sprite, memptr, 8, 16, g_tablatrans);
}

void entityDrawUpdate(Tpersonaje* p){
   
   //p->nframe = 0;
   u8* x = p->x +2;
   u8* y = p->y +2;
   u8* px = p->px +2;
   u8* py = p->py +2;
   u8* n = p->nframe +2;
   *x = *(x-1); --x; *x = *(x-1);
   *y = *(y-1); --y; *y = *(y-1);
   *n = *(n-1); --n; *n = *(n-1);
   *py = *(py-1); --py; *py = *(py-1);
   *px = *(px-1); --px; *px = *(px-1);

   //resetAnim();
   
   --p->draw;

}

void andando_r(Tpersonaje* p){
	if(++p->nframe[0] == MOVE_FRAMES_R*ANIM_PAUSA){
		p->nframe[0] = 0;
	}
}

void andando_l(Tpersonaje* p){
	if(++p->nframe[0] == MOVE_FRAMES_L*ANIM_PAUSA){
		p->nframe[0] = 0;
	}
}

void andando_u(Tpersonaje* p){
	if(++p->nframe[0] == MOVE_FRAMES_U*ANIM_PAUSA){
		p->nframe[0] = 0;
	}
}

void andando_d(Tpersonaje* p){
	if(++p->nframe[0] == MOVE_FRAMES_D*ANIM_PAUSA){
		p->nframe[0] = 0;
	}
}

void asignarFrame(TFrame **animacion, Tpersonaje* p) {
   p->frame = animacion[p->nframe[0] / ANIM_PAUSA];
}


void selectSprite(Tpersonaje* p) {
   switch(p->estado) {
	      case ST_quieto:      { if(p->mirar==1){
									   	p->frame = &g_frames[0];
									   }else if (p->mirar==2){
									   	p->frame = &g_frames[4];
									   }else if (p->mirar==3){
									   	p->frame = &g_frames[10];
									   }else{
									   	p->frame = &g_frames[8];
									   }  
		  break; }
      case ST_andando_r:     { asignarFrame(anim_andar_r, p);    break; }
      case ST_andando_l:   { asignarFrame(anim_andar_l, p);   break; }
      case ST_andando_u:    { asignarFrame(anim_andar_u, p); break; }
      case ST_andando_d:     { asignarFrame(anim_andar_d, p); break; }
   }
}

void stateExe(Tpersonaje* p) {
   switch(p->estado) {
      case ST_andando_r:   andando_r(p);     break;
      case ST_andando_l:   andando_l(p);   break;
      case ST_andando_u:   andando_u(p);    break;
      case ST_andando_d:   andando_d(p);     break;
   }
}

void moveRight(Tpersonaje* p, u8 mapanew[]){

   if( p->x[0] < 72 && (mapanew[4+(p->tile)] != 1) && (mapanew[84+(p->tile)]!= 1) && (mapanew[164+(p->tile)]!= 1)) {
   		p->x[0] += 1;
   		p->estado = ST_andando_r;
   		p->mirar = 1;
   	     resetAnim(p);
	}
}

void moveLeft(Tpersonaje* p, u8 mapanew[]){

   if ( p->x[0] > 0 && (mapa[-1+(p->tile)] != 1) && (mapa[79+(p->tile)]!= 1) && (mapa[159+(p->tile)]!= 1)) {
   		p->x[0] -= 1;
   		p->estado = ST_andando_l;
   		p->mirar = 2;
   		resetAnim(p);
	}	   
}

void moveUp(Tpersonaje* p, u8 mapanew[]){

   if ( p->y[0] > 0 && (mapa[-40+(p->tile)] != 1) && (mapa[-38+(p->tile)]!= 1) && (mapa[-37+(p->tile)]!= 1)) {
   		p->y[0] -= 3;
   		p->estado = ST_andando_u;
   		p->mirar = 3;
   		resetAnim(p);
	}
}

void moveDown(Tpersonaje* p, u8 mapanew[]){

   if ( p->y[0] < 184 && (mapa[200+(p->tile)] != 1) && (mapa[202+(p->tile)]!= 1) && (mapa[203+(p->tile)]!= 1)) {
   		p->y[0] += 3;
   		p->estado = ST_andando_d;
   		p->mirar = 0;
         resetAnim(p);
   }
}

void resetAnim(Tpersonaje* p){

   if(p->estado != p->lestado){
      p->nframe[0] = 0;
      p->lestado = p->estado;
   }
   p->move = SI;
   p->tile=((p->x[0]/2)+(p->y[0]/4)*40);
}

void Stop(Tpersonaje* p){
   if(p->move == SI) p->draw = 2;
	p->move = NO;
   p->estado = ST_quieto;
   	
}

