/***********Personaje**************/

#include "knight_spritesheet.h"
#include "constants.h"

#define KNIGHT_FRAMES  12

//ESTRUCTURA FRAMES
typedef struct {
   u8* sprite;
} TFrame;
//ESTRUCTURA PERSONAJE
typedef struct {
	u8 x[3], y[3];
	u8 px[3], py[3];
	u16 tile;
	u8* sprite;
	u8* move;
	u8 estado;
    TFrame* frame;
    u8 nframe[3];
    u8 lestado;
    u8 mirar;
  u8 vida;
  u16 score;
  u8 draw;
  u8 anim;
} Tpersonaje;
// Eventos del personaje
extern enum {
      EV_detenerse = 0
   ,  EV_moverse
} EEventos;

// Estados del personaje
extern enum {
      ST_quieto = 0
   ,  ST_andando_r
   ,  ST_andando_l
   ,  ST_andando_u
   ,  ST_andando_d
   ,  ST_numEstados
} EEstados;

extern const TFrame g_frames[KNIGHT_FRAMES];

extern TFrame* const anim_andar_r[MOVE_FRAMES_R];
extern TFrame* const anim_andar_l[MOVE_FRAMES_L];
extern TFrame* const anim_andar_u[MOVE_FRAMES_U];
extern TFrame* const anim_andar_d[MOVE_FRAMES_D];

void iniciarPersonaje(Tpersonaje *p, u8 x, u8 y);

void andando_r(Tpersonaje *p);

void andando_l(Tpersonaje *p);

void andando_u(Tpersonaje *p);

void andando_d(Tpersonaje *p);

void asignarFrame(TFrame **animacion, Tpersonaje *p);

void selectSprite(Tpersonaje *p);

void stateExe(Tpersonaje *p);

void moveRight(Tpersonaje* p, u8 mapanew[]);

void moveLeft(Tpersonaje* p, u8 mapanew[]);

void moveUp(Tpersonaje* p, u8 mapanew[]);

void moveDown(Tpersonaje* p, u8 mapanew[]);

void resetAnim(Tpersonaje* p);

void Stop(Tpersonaje* p);

void clearEntity(Tpersonaje* p);
void drawEntity(Tpersonaje* p);
void entityDrawUpdate(Tpersonaje* p);